package fr.jussieu.linguist.depLin;

import org.jdom.Element;
import org.jdom.input.SAXBuilder;
import java.util.*;
import javax.sound.sampled.*;
import java.io.*;
import java.awt.Font;
//import javax.swing.JFrame;


/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class DepLinLips {
    ArrayList[] wordsAndComm;
    ArrayList fileNameList;
    ArrayList clips;
    DepLinFrame motherFrame;
    Font wordFont;
    File rulesFile;
    SAXBuilder saxBuilder;
    Element lips;
    Hashtable markups;
    String neutralMarkup;
    String unmarkedMarkup;
    String audioDirectory;

    public DepLinLips(File rules, Element root, DepLinFrame mf, Font font) {

	motherFrame = mf;
	wordFont = font;
	rulesFile = rules;
	markups = new Hashtable();
	saxBuilder = new SAXBuilder();
	readRules();

	wordsAndComm = getWordsAndComm(root,"?");
	if (wordsAndComm==null)
		  {warn("I can't speak without communicative information - I don't want to sound like a computer!");return;}
	fileNameList = getFileList(wordsAndComm);
	clips = getClipArray(fileNameList);

    }


void speak()
{
    if (clips == null) return;

    String text="<i><b><font color='#7D007D' size=+1>What I'm trying to say is that </font></b></i><br>";
    String soundfiletext="(files: ";
    text += "<font size=+2>";

    for (int i = 0; i < wordsAndComm[0].size(); i++) {
	String word = wordsAndComm[0].get(i).toString();
	String comm = wordsAndComm[1].get(i).toString();
	text += "<font face='" +wordFont.getName()+"'>"+word+"</font><sub><font color='#FF9900'> "
         + comm	+"</font></sub> ";
	soundfiletext+= " "+(i+1)+". "+fileNameList.get(i)+ " ";
    }
    text += "</font>";
    text += "<br>"+soundfiletext+" )";

    motherFrame.topPhonoPanel.linearTextPanel.showInBig(text);




    new Thread()
    {
	public void run(){
	    Clip thisclip=null;
	    for (int i = 0; i < clips.size(); i++) {
		thisclip = (Clip) clips.get(i);
		thisclip.start();

		while(thisclip.isActive()){}
	    }
//	    System.out.println("---"+ thisclip.isActive());



//	    for (int i = 0; i < clips.size(); i++) {
//		thisclip = (Clip) clips.get(i);
//
//		thisclip.stop();
//		thisclip.close();
//	    }
	}
	}.start();
}


ArrayList getClipArray(ArrayList nameList)
{
    int numberWords = nameList.size();
    ArrayList clipar = new ArrayList(numberWords);
    for (int i = 0; i < numberWords; i++)
    {
	Clip clip = null;
	File soundFile = new File(nameList.get(i).toString());

	if(!soundFile.exists())
	{
	    warn(soundFile.getName()+" does not exist! You gotta do something about it!");
	    return null;
	}
	javax.sound.sampled.AudioInputStream ais=null;
	try {ais = javax.sound.sampled.AudioSystem.getAudioInputStream(soundFile);ais.read();}
	catch (UnsupportedAudioFileException ex) {System.out.println("xxx");}
	catch (IOException ex) {}

	DataLine.Info info = new DataLine.Info(Clip.class,ais.getFormat());

	try{clip = (Clip) AudioSystem.getLine(info);clip.open(ais);}
	catch (LineUnavailableException ee){System.out.println("line unavailable");}
	catch(IOException eee){}

	clipar.add(clip);

    }

return clipar;

}

ArrayList getFileList(ArrayList[] wac)
{

int wordnumber=0;
int totalwords = wac[0].size();
ArrayList list = new ArrayList(totalwords);

// try to apply a prosodic Scheme
/** @todo do something with many prosodic schemes, for the moment only the last is played */
for (Iterator i = lips.getChildren("prosodicScheme").iterator(); i.hasNext(); )
  {
    Element prosdicScheme = (Element)i.next();
    motherFrame.statusBar.setText("prosodic scheme: "+prosdicScheme.getAttributeValue("name"));
    for (Iterator j = prosdicScheme.getChildren("prosodicGroup").iterator(); j.hasNext(); ) {
	String prosdicGroupName = ((Element)j.next()).getAttributeValue("name");
	int advancement=0;
	while(wordnumber<totalwords && (wac[1].get(wordnumber).equals(prosdicGroupName)
					|| wac[1].get(wordnumber).equals(unmarkedMarkup)))
	{

	    String fileName =audioDirectory+"/";

	    // is it unmarked?
	    if(wac[1].get(wordnumber).equals(unmarkedMarkup))
	       fileName+=wac[0].get(wordnumber)+".wav";
	    // is it at the end of the prosodic group?
	    else if((wordnumber+1==totalwords)||!(wac[1].get(wordnumber+1).equals(prosdicGroupName)
		    || wac[1].get(wordnumber+1).equals(unmarkedMarkup)))
	       fileName+=wac[0].get(wordnumber)+"."+markups.get(wac[1].get(wordnumber)+"end")+".wav";
            // is it at the beginning?
	    else if(advancement==0)
	      fileName+=wac[0].get(wordnumber)+"."+markups.get(wac[1].get(wordnumber)+"start")+".wav";
            // no ? so it's in the middle!
            else
		fileName+=wac[0].get(wordnumber)+"."+markups.get(wac[1].get(wordnumber)+"middle")+".wav";

	    list.add(fileName);
	    advancement++;
	    wordnumber++;

	}
    }



    if (wordnumber<totalwords) // default: no grouping
    {
	motherFrame.statusBar.setText(prosdicScheme.getAttributeValue("name")+" could not be applied!");
	for (int wn = wordnumber; wn < totalwords; wn++) {
	    String fileName =audioDirectory+"/";
	    fileName+=wac[0].get(wn)+"."+markups.get(wac[1].get(wn)+"end")+".wav";
	    list.add(fileName);
	}

    }
}
return list;


}

    ArrayList[] getWordsAndComm(Element el, String higherComm) {

	ArrayList wordList = new ArrayList();
	ArrayList commList = new ArrayList();

	ArrayList[] wordComm={wordList,commList};

	if (el.getName().equals("word"))
	{
	    String thisName = el.getAttributeValue("name");
	    String thisComm = el.getAttributeValue("comm");
	    if (thisComm==null) return null;
	    if (thisComm.equals(neutralMarkup))	thisComm = higherComm;
	    wordList.add(thisName);
	    commList.add(thisComm);
	    ArrayList[] wc = {wordList,commList};
	    wordComm = wc;
	}
	else
	{
	    String thisComm = el.getAttributeValue("comm");
	    if(thisComm!=null && !thisComm.equals(neutralMarkup) && !thisComm.equals(unmarkedMarkup) )
	         higherComm = el.getAttributeValue("comm");
	    Iterator iter = el.getChildren().iterator();
	    while (iter.hasNext()) {
		Element nextEl = (Element)iter.next();
		ArrayList[] arrayKid = getWordsAndComm(nextEl, higherComm);
		if (arrayKid==null) return null;
		wordComm[0].addAll(arrayKid[0]);
		wordComm[1].addAll(arrayKid[1]);
	    }
	}

	return wordComm;

    }

    void warn(String text)
     {
       DepLinFrame_WarnBox warn = new DepLinFrame_WarnBox(motherFrame,text );
       java.awt.Dimension dlgSize = warn.getPreferredSize();
       java.awt.Dimension frmSize = motherFrame.getSize();
       java.awt.Point loc = motherFrame.getLocation();
       warn.setLocation((frmSize.width - dlgSize.width) / 2 + loc.x, (frmSize.height - dlgSize.height) / 2 + loc.y);
       warn.setModal(true);
       warn.show();
  }



void readRules()
{

    try {

	lips= (saxBuilder.build(rulesFile)).getRootElement();
	}
	 catch (Exception eee) { eee.printStackTrace();}

	 for (Iterator i = lips.getChildren("prosodicGroup").iterator(); i.hasNext(); ) {
	     Element nextEl = (Element)i.next();
	     markups.put(nextEl.getAttributeValue("name")+"start",
			 nextEl.getChild("start").getAttributeValue("markup"));
	     markups.put(nextEl.getAttributeValue("name")+"middle",
			 nextEl.getChild("middle").getAttributeValue("markup"));
	     markups.put(nextEl.getAttributeValue("name")+"end",
			 nextEl.getChild("end").getAttributeValue("markup"));

	 }

	 neutralMarkup = lips.getChild("neutral").getAttributeValue("name");
	 unmarkedMarkup = lips.getChild("unmarked").getAttributeValue("name");
	 audioDirectory = lips.getChild("directory").getAttributeValue("name");
}


}
