package fr.jussieu.linguist.depLin;

import org.jdom.Element;
import org.jdom.input.SAXBuilder;
import java.util.*;
import javax.sound.sampled.*;
import java.io.*;
import java.awt.Font;
/**
 * <p>Title: </p>
 * <p>Description: </p>
 * <p>Copyright: Copyright (c) 2001</p>
 * <p>Company: </p>
 * @author unascribed
 * @version 1.0
 */

public class TopPhonoGrammar
{
    ArrayList contractionList=new ArrayList();
    Hashtable unaccentedCatTable=new Hashtable();
    Hashtable groupCombiTable=new Hashtable();

    ArrayList topWordList=new ArrayList();
    ArrayList phonoWordList=new ArrayList();

    DepLinFrame motherFrame;

    File ruleFile;
    SAXBuilder saxBuilder;

    Element prosodicSentence;
    Element prosodicGroup;
    Element prosodicWord;

    Element sentenceNode;

    ArrayList prosodicGroupCommMarkups=new ArrayList();

    public Element phonologiesRoot;


    public TopPhonoGrammar(File ruleFile,  DepLinFrame mf)
    {

	motherFrame = mf;
	this.ruleFile = ruleFile;
	saxBuilder = new SAXBuilder();
        phonologiesRoot = new Element("phonologies");
	readRuleFile();
    }



    public void applyGrammarTo(Element topElement)
       {

         Element currentPhonology = new Element("phonology");
         topWordList  = new ArrayList();
         sentenceNode = ((Element) prosodicSentence.clone()).detach();
         String sentenceType = topElement.getAttributeValue("sentenceType");
         if(sentenceType==null) sentenceNode.setAttribute("comm","declarative");
         else sentenceNode.setAttribute("comm",sentenceType);
         currentPhonology.addContent(sentenceNode);

         // here we go down the tree
         trackBoxDown(topElement.getChild("field").getChild("box"),null);

         phonologiesRoot.addContent(currentPhonology);
         phonoWordList = new ArrayList();
         wordCombination();
         groupCombination(0,0);


       }//end apply grammar


    Element trackBoxDown(Element topBox, Element prosodicGroup)
       {
         // loop through fields
         for (Iterator i = topBox.getChildren("field").iterator(); i.hasNext(); )
         {
           Element nextField = (Element)i.next();

           // loop through boxes
           for (Iterator ii = nextField.getChildren().iterator(); ii.hasNext(); )
           {
             Element nextEle = (Element)ii.next();
             if("word".equals(nextEle.getName()))
             {
               if(prosodicGroup == null)
               {
                 prosodicGroup = makeNewProsodicGroup(nextEle);
                                      // is a prosodicGroup with the same comm value as the word
                 sentenceNode.addContent(prosodicGroup);
               }

               Element newProsoWord = makeNewProsodicWord(nextEle);

               Element wordCopy = ((Element) nextEle.clone()).detach();

               // the prosodicGroup has topBox's comm value. in case the word has a better one:
               transferBetterCommValue(wordCopy,prosodicGroup);

               newProsoWord.addContent(wordCopy);
               prosodicGroup.addContent(newProsoWord);
               topWordList.add(wordCopy);
             }
             if("box".equals(nextEle.getName()))
             {
               if(contractionRuleExists(topBox.getAttributeValue("name"),
                                        topBox.getAttributeValue("comm"),
                                        nextField.getAttributeValue("name"),
                                        nextEle.getAttributeValue("name"),
                                        nextEle.getAttributeValue("comm")))
               { // if the child box can contract with its father
                 // then see if the child box has a prosodic group
                 // (i.e. it has directly a word inside it or has a contracting domain that has a word)
                 prosodicGroup = trackBoxDown(nextEle,prosodicGroup);
               }
               else
               {
                   prosodicGroup = null;
                   trackBoxDown(nextEle,prosodicGroup);
               }



             }
           }

         }
         return prosodicGroup;
    }


  Element makeNewProsodicGroup(Element commExemple)
    {
      Element newProsoG = ((Element) prosodicGroup.clone()).detach();
      if (commExemple.getAttributeValue("comm")==null)
        newProsoG.setAttribute("comm","?");
      else newProsoG.setAttribute("comm",commExemple.getAttributeValue("comm"));
      return newProsoG;
}
    Element makeNewProsodicWord(Element commExemple)
    {
      Element newProsoWord = ((Element) prosodicWord.clone()).detach();
      if (commExemple.getAttributeValue("comm")==null)
        newProsoWord.setAttribute("comm","?");
      else newProsoWord.setAttribute("comm",commExemple.getAttributeValue("comm"));
      return newProsoWord;
    }


void transferBetterCommValue(Element topWordOrBox, Element prosoG)
{
      // if the prosodic group has a weird comm markup, like neutral (N)
      if (!prosodicGroupCommMarkups.contains(prosoG.getAttributeValue("comm")))
      { // then try to get a better one from a word
        String wordComm = topWordOrBox.getAttributeValue("comm");
        if(wordComm!=null&&prosodicGroupCommMarkups.contains(wordComm))
          prosoG.setAttribute("comm",wordComm);
      }

    }





void wordCombination()
{
  for (int i=0;i < topWordList.size(); i++)
        {
          Element thisWord = (Element)topWordList.get(i);

//          System.out.println("____"+thisWord.getAttributeValue("name"));



          if(unaccentedCatTable.containsKey(thisWord.getAttributeValue("cat")))
          {

//            System.out.println("combines");
            String direction = (String)unaccentedCatTable.
                               get(thisWord.getAttributeValue("cat"));
            if("right".equals(direction)&&i+1<topWordList.size())
            {
              Element nextWord = (Element)topWordList.get(i+1);
              Element grandparent = thisWord.getParent().getParent();
              if(grandparent.getChildren().size()==1)//in case pw is alone in pg
                grandparent.detach();
              else   thisWord.getParent().detach();
              thisWord.detach();
              nextWord.getParent().getChildren().add(0,thisWord);
              phonoWordList.add(nextWord.getParent().getChildren().get(0));

            }
            else if("left".equals(direction)&&i>1)
            {
              Element prevWord = (Element)topWordList.get(i-1);
              Element grandparent = thisWord.getParent().getParent();
              if(grandparent.getChildren().size()==1)
                grandparent.detach();
              else thisWord.getParent().detach();
              thisWord.detach();
              prevWord.getParent().addContent(thisWord);
              phonoWordList.add(thisWord);
            }

          }
          else               phonoWordList.add(thisWord);
        }
}


      void groupCombination(int currentPhonologyNumber, int currentStartGroup)
      {

       Element thisPhonology = (Element) phonologiesRoot.getChildren().get(currentPhonologyNumber);

       List phGroupList = thisPhonology.getChild("prosodicSentence").getChildren();

         for (int i=currentStartGroup;i < phGroupList.size()-1; i++){

           Element thisGroup= (Element)phGroupList.get(i);
           Element nextGroup = (Element)phGroupList.get(i+1);
           if(groupsCanCombine(thisGroup,nextGroup)){
             if("yes".equals(groupCombiTable.get(thisGroup.getAttributeValue("comm"))))
             {// if the combination is optional
               Element phonologyCopy = ((Element)thisPhonology.clone()).detach();
               combineGroups(thisGroup,nextGroup);
               groupCombination(0, i);
               phonologiesRoot.getChildren().add(0,phonologyCopy);
               groupCombination(0, i+1);
               break;
             }
             else {
               combineGroups(thisGroup,nextGroup);
               groupCombination(0, i);
             }


           }



         }

      }

      boolean groupsCanCombine(Element firstGroup, Element secondGroup){
        String firstGroupComm = firstGroup.getAttributeValue("comm");
        return (firstGroupComm.equals(secondGroup.getAttributeValue("comm"))
                && groupCombiTable.containsKey(firstGroupComm));
      }

      void combineGroups(Element firstGroup, Element secondGroup) {
        // the second disappears, the first survives
        secondGroup.detach();
        List allchildren = firstGroup.getChildren();
        allchildren.addAll(secondGroup.getChildren());
        firstGroup.removeChildren();
        secondGroup.removeChildren();
        firstGroup.setContent(allchildren);

      }












//    void makeProsodicWords(Element topElement)
//    {
//  ArrayList leaves = new ArrayList();
//  getLeavesList(topElement,leaves);
//  Iterator iter = leaves.iterator();
//  while (iter.hasNext())
//  {
//    Element next = (Element)iter.next();
//
//  }
//
//
//}


boolean contractionRuleExists(String topDomain, String topComm,
	String	field, String	bottomDomain , String	bottomComm)
{
    Iterator iter = contractionList.iterator();
    while (iter.hasNext())
    {
		  TopPhonoContractionRule nextRule = (TopPhonoContractionRule)iter.next();
		  if(
                        ("?".equals(nextRule.topDomain)||nextRule.topDomain.equals(topDomain) )
		     && ("?".equals(topComm)|| "?".equals(nextRule.topComm)||nextRule.topComm.equals(topComm))
		     && ("?".equals(nextRule.field)|| nextRule.field.equals(field))
		     && ("?".equals(nextRule.bottomDomain)||nextRule.bottomDomain.equals(bottomDomain))
		     && ("?".equals(bottomComm)||"?".equals(nextRule.bottomComm)||nextRule.bottomComm.equals(bottomComm)))
	             return true;

    }
    return false;

}





  void readRuleFile() {

    Element topPhonoRulesTree;
    try {
      topPhonoRulesTree = (saxBuilder.build(ruleFile)).getRootElement();
      for (Iterator i = topPhonoRulesTree.getChildren("domainContraction").
           iterator(); i.hasNext(); )
	    {
		Element nextEl = (Element)i.next();
		TopPhonoContractionRule contraction = new TopPhonoContractionRule();
		contraction.topDomain = nextEl.getChild("topDomain").getAttributeValue("name");
		contraction.topComm = nextEl.getChild("topComm").getAttributeValue("name");
		contraction.field = nextEl.getChild("field").getAttributeValue("name");
		contraction.bottomDomain = nextEl.getChild("bottomDomain").getAttributeValue("name");
		contraction.bottomComm = nextEl.getChild("bottomComm").getAttributeValue("name");
		contractionList.add(contraction);
	    }


       for (Iterator i = topPhonoRulesTree.getChildren("prosodicWordCombination").iterator();
                 i.hasNext(); )
	    {
		Element nextEl = (Element)i.next();
		unaccentedCatTable.put(nextEl.getAttributeValue("cat"),
					nextEl.getAttributeValue("direction"));
	    }


      for (Iterator i = topPhonoRulesTree.getChildren("prosodicGroupCombination").iterator();
                 i.hasNext(); )
            {
                Element nextEl = (Element)i.next();
                groupCombiTable.put(nextEl.getAttributeValue("comm"),
                                        nextEl.getAttributeValue("optional"));
	    }

      prosodicSentence = topPhonoRulesTree.getChild("prosodicSentence");
      prosodicGroup = topPhonoRulesTree.getChild("prosodicGroup");
      prosodicWord = topPhonoRulesTree.getChild("prosodicWord");

      for (Iterator i = topPhonoRulesTree.getChild("prosodicGroupCommMarkups").
                 getChildren("markup").iterator(); i.hasNext(); )
            {
              Element nextEl = (Element) i.next();
              prosodicGroupCommMarkups.add(nextEl.getAttributeValue("name"));
            }

    }
   catch (Exception eee) { eee.printStackTrace();}

   }





}
